Menu = require 'menu'


function love.load()
	love.graphics.setBackgroundColor(50,50,50)
	scope = love.graphics.newImage("assets/scope.png")
	map1 = love.graphics.newImage("assets/skyscraper.png")
	target = love.graphics.newImage("assets/target.png")
	posset = 0
	wait = 3
	time = 0
	
	gamestate = 0 -- 0 means menu, 1 means singleplayer, 2 means multiplayer, 3 means gameover
	startmenu = Menu.new()
	startmenu:addItem{
		name = 'Start Single Player',
      	action = function()
			gamestate = 1
		end
   }
   startmenu:addItem{
      name = 'Start Multiplayer',
      action = function()
		gamestate = 2
      end
   }
   startmenu:addItem{
      name = 'Quit',
      action = function()
         love.event.quit()
      end
   }
end

function love.update(dt)
startmenu:update(dt)
	if gamestate == 1 then
		xp = love.mouse.getX() - 1280
		yp = love.mouse.getY() - 720
		time = time + dt
		if posset == 0 then
			--tarx = love.math.random(1250)
			--tary = love.math.random(690)
			tarx = ((love.math.random(5)*200)+135)
			tary = ((love.math.random(2)*200)+140)
			posset = 1
		end
	elseif gamestate == 3 then
	end
end

function love.draw(dt)
	startmenu:draw(10, 10)
   	if gamestate == 1 then
   		love.graphics.clear()
		love.graphics.draw(map1, 0, 0)
		love.graphics.draw(target, tarx, tary)
		love.graphics.draw(scope, xp, yp)
	elseif gamestate == 3 then
		love.graphics.clear()
		love.graphics.print("Game Over", 640, 360)
		love.graphics.print("Time :"..tostring(time).."s", 640, 380)
		love.graphics.print("Press Enter to Continue", 640, 400)
		posset = 0
		
	elseif gamestate == 0 then
		love.graphics.clear()
		startmenu:draw(10, 10)
		time = 0
   end
   	love.graphics.print("FPS: "..tostring(love.timer.getFPS()), 1100, 10)
	love.graphics.print("Mouse X: "..tostring(love.mouse.getX()), 1100, 20)
	love.graphics.print("Mouse Y: "..tostring(love.mouse.getY()), 1100, 30)
	love.graphics.print("Gamestate: "..tostring(gamestate), 1100, 40)
end

function love.keypressed(key)
   startmenu:keypressed(key)
   if key == "tab" then
      local state = not love.mouse.isVisible()   -- the opposite of whatever it currently is
      love.mouse.setVisible(state)
   end
   if key == "return" and gamestate == 3 then
   	gamestate = 0
   end
end

function love.mousepressed(x, y, button)
	if gamestate == 1 and tarx<x and x<tarx+30 then
		if tary<y and y<tary + 60 then
			gamestate = 3
		end
	end
end